/*
 *   $Id: mwapi_event.h,v 1.3 2025/03/09 19:50:47 snw Exp $
 *    mwapi event support
 *
 *  
 *   Author: Serena Willis <snw@coherent-logic.com>
 *    Copyright (C) 1998 MUG Deutschland
 *    Copyright (C) 2014, 2020, 2021, 2025 Coherent Logic Development LLC
 *
 *
 *   This file is part of FreeM.
 *
 *   FreeM is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   FreeM is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero Public License for more details.
 *
 *   You should have received a copy of the GNU Affero Public License
 *   along with FreeM.  If not, see <https://www.gnu.org/licenses/>.
 *
 *   $Log: mwapi_event.h,v $
 *   Revision 1.3  2025/03/09 19:50:47  snw
 *   Second phase of REUSE compliance and header reformat
 *
 *
 * SPDX-FileCopyrightText:  (C) 2025 Coherent Logic Development LLC
 * SPDX-License-Identifier: AGPL-3.0-or-later
 **/

#include "config.h"

#if !defined(__MWAPI_EVENT_H) && defined(HAVE_MWAPI_MOTIF)
# define __MWAPI_EVENT_H

#include <Xm/Xm.h>

typedef struct mwapi_event {

    char *evclass;
    char *window_name;

    char *entryref;
    
    Widget *window;
    
    
} mwapi_event;

typedef struct mwapi_event_queue_entry {

    mwapi_event *e;

    struct mwapi_event_queue_entry *next;

} mwapi_event_queue_entry;


extern mwapi_event_queue_entry *mwapi_event_queue_head;
extern short evt_sync_enabled;

mwapi_event *mwapi_event_new(char *evclass, char *window_name, Widget *window);
void mwapi_wire_event(mwapi_event *e, char *entryref);
void mwapi_enqueue_event(Widget *widget, void *data);
int mwapi_dequeue_events(char *result);
void mwapi_on_merge_complete(char *window_name);

#endif
