/*
 *   $Id: mwapi_window.h,v 1.4 2025/03/22 18:43:54 snw Exp $
 *    mwapi window support
 *
 *  
 *   Author: Serena Willis <snw@coherent-logic.com>
 *    Copyright (C) 1998 MUG Deutschland
 *    Copyright (C) 2014, 2020, 2021, 2025 Coherent Logic Development LLC
 *
 *
 *   This file is part of FreeM.
 *
 *   FreeM is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   FreeM is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero Public License for more details.
 *
 *   You should have received a copy of the GNU Affero Public License
 *   along with FreeM.  If not, see <https://www.gnu.org/licenses/>.
 *
 *   $Log: mwapi_window.h,v $
 *   Revision 1.4  2025/03/22 18:43:54  snw
 *   Make STRLEN 255 chars and add BIGSTR macro for larger buffers
 *
 *   Revision 1.3  2025/03/09 19:50:47  snw
 *   Second phase of REUSE compliance and header reformat
 *
 *
 * SPDX-FileCopyrightText:  (C) 2025 Coherent Logic Development LLC
 * SPDX-License-Identifier: AGPL-3.0-or-later
 **/

#include "config.h"

#if !defined(__MWAPI_WINDOW_H) && defined(HAVE_MWAPI_MOTIF)
# define __MWAPI_WINDOW_H

#include <Xm/Xm.h>

typedef struct mwapi_window {

    char window_name[255];
    Widget *window;

    short win_visible;
    
    struct mwapi_window *next;

} mwapi_window;

void mwapi_default_destroy_handler(Widget *widget, void *data);
void mwapi_on_merge_complete(char *window_name);
void mwapi_foreach(void (*callback)(mwapi_window *));
int mwapi_win_count(void);
void mwapi_win_show_all(void);
void mwapi_win_show(mwapi_window *win);
mwapi_window *mwapi_win_get(char *window_name);

#endif
